// regex_search example from http://www.cplusplus.com/reference/regex/regex_search/
#include <iostream>
#include <string>
#include <regex>

int main ()
{
  //std::string s ("this subject has a submarine as a subsequence");
  //std::regex e ("\\b(sub)([^ ]*)");   // matches words beginning by "sub"
  
  std::string s ("aäbc+A");
  std::string pat ("[a-b]");
  std::regex e (pat);   // matches characters a and b, check if ä is matched
  
  
  std::locale old;
  #ifdef _WIN32
	std::setlocale(LC_ALL, "english");
 #else
	std::locale::global(std::locale("en_US.UTF-8"));
 #endif
 
  
  std::smatch m;

  std::cout << "Target sequence: " << s << std::endl;
  std::cout << "Regular expression: " << pat << std::endl;
  std::cout << "The following matches and submatches were found:" << std::endl;

  while (std::regex_search (s,m,e)) {
    for (auto x:m) std::cout << x << " ";
    std::cout << std::endl;
    s = m.suffix().str();
  }
  
  std::locale::global(old);

  return 0;
}
