// regex_search example from http://www.cplusplus.com/reference/regex/regex_search/
#include <iostream>
#include <string>
#include <regex>
#include "utf8_v2_3_4/source/utf8.h"

int main ()
{
  //Search using wide strings:
  
  std::locale old;
  #ifdef _WIN32
	std::setlocale(LC_ALL, "english");
 #else
	std::locale::global(std::locale("en_US.UTF-8"));
 #endif
 
  std::string s0 ("aäbc+Aa");
  std::wstring s;
  utf8::utf8to16(s0.begin(),s0.end(),back_inserter(s));
  std::string pat ("[a-b]");
  std::wstring wpat;
  utf8::utf8to16(pat.begin(),pat.end(),back_inserter(wpat));
  std::wregex e (wpat, std::regex_constants::collate);   // matches characters a and b, check if ä is matched
  
  std::wsmatch m;

  std::cout << "Target sequence: " << s0 << std::endl;
  std::cout << "Regular expression: " << pat << std::endl;
  std::cout << "The following matches and submatches were found:" << std::endl;

  while (std::regex_search (s,m,e)) {
	    std::wstring wmatch = s.substr(m.position(),m.length());
	    std::string matchstr;
	    utf8::utf16to8(wmatch.begin(), wmatch.end(), back_inserter(matchstr));
	    std::cout << "match found: " << matchstr << " of length " << m.length() << " at position " << m.position() << std::endl;
    std::cout << std::endl;
    s = m.suffix().str();
  }

  std::locale::global(old);

  return 0;
}
