% -*- coding: utf-8 -*-
:- assertz(user:file_search_path(probsrc,'../../src/')).
:- assert(user:library_directory('.')).

portray_message(informational, _).

:- use_module(regexp).
:- use_module(library(plunit)).


:- begin_tests(regexp_search_all).
test(all1, [setup(regexp_init)]) :- regexp_search_all('aäbcd','[a-c]',All1), print(all1(All1)),nl,
   All1 == [a,b,c]. % does not work on Linux/Windows where ä is included
:- end_tests(regexp_search_all).


:- use_module(probsrc(tools_printing),[format_with_colour/4]).

test :-  run_tests(all,[quiet,failed(F),passed(P),skipped(S)]),
         (F>0 ->
           format_with_colour(user_error,[red,bold],'~nTests: ~w passed, ~w skipped, ~w failed~n~n',[P,S,F]),
           halt(1) ;
           format_with_colour(user_output,[green,bold],'~nTests: ~w passed, ~w skipped, ~w failed~n~n',[P,S,F])).


bench :- statistics(walltime,_),
         run_tests,
         statistics(walltime,[_,Delta]) , print(walltime(Delta)),nl.
