#ifndef MID_H_INCLUDED
#define MID_H_INCLUDED

#include "../common/hashtrie.h"

#include <zmq.h>
#include <czmq.h>

struct id_map {
    size_t len;
    char **id_map;
    int *ports;
};

/* creates a TCP id reply zocket on port portnumber;
 * sets the model to given model with size len;
 * returns the new zocket */
zsock_t *master_id_setup(const int portnumber);

/* tears down an id map */
void teardown_id_map(struct id_map * ips);

/* receives exactly one id request and replies with an id and a model
 * message will contain all known hashcodes if send_hashes is != 0
 * returns the cmd it received */
int master_h_id(zsock_t * const zocket,
                char * const master_ip,
                const int port_pub,
                struct id_map * const ips,
                zchunk_t const * const model,
                const int send_hashes,
                hashtrie trie);

struct mid_args {
    struct id_map *ips;
    char *master_ip;
    int port_pub;
    zchunk_t *model;
    int send_hashes;
    hashtrie trie;
};

/* reader function for master_h_id */
int mid_reader(zloop_t *loop, zsock_t *reader, void *arg);

#endif
