#ifndef P_PUB_SUB_H_INCLUDED
#define P_PUB_SUB_H_INCLUDED

#include "../common/hashtrie.h"
#include "pstats.h"


void put_hashes(zmsg_t *msg, const hashtrie trie, int fd_logfile);
int handle_sub(zsock_t * const sub,
               const int is_stream_sub,
               zsock_t * const pub_local,
               zsock_t * const pub_global,
               zsock_t * const push,
               pStats * const stats,
               const int id,
               const size_t thresh,
               const int port_start,
               const int fd_logfile,
               const hashtrie trie,
               const int proxynumber);

int local_balance(zsock_t * const pub,
                  pStats * const wqs,
                  const size_t thresh,
                  const int port_start,
                  const int fd_logfile,
                  const int proxynumber);

struct p_sub_args {
    zsock_t *pub_local;
    int is_stream_sub;
    zsock_t *pub_global;
    zsock_t *push;
    pStats * stats;
    int proxy_id;
    size_t thresh;
    int port_start;
    int fd_logfile;
    hashtrie trie;
    int proxynumber;
};

int proxy_sub_reader(zloop_t *loop, zsock_t *reader, void *args);

zsock_t *proxy_setup_sub(char const * const endpoint);
void proxy_add_subscription(zsock_t *sub, char const * const master_ip, int port);
zsock_t *proxy_setup_pub(const int proxy_id);
zsock_t *proxy_setup_sub2(char const * const ip, const int port);

#endif
