#ifndef P_PULL_PUSH_INCLUDED
#define P_PULL_PUSH_INCLUDED

#include "../common/hashtrie.h"
#include "pstats.h"

void psend_stats(zsock_t * const zocket,
                 const int id,
                 pStats const * const wqs,
                 const int port_start,
                 const int proxynumber,
                 const int fd_logfile);

void p_send_transfer_done(zsock_t * const push,
                          const int id,
                          pStats const * const wqs,
                          const int port_start,
                          const int proxynumber,
                          const int fd_logfile,
                          const uint64_t timestamp);

void proxy_h_pull(zsock_t * const pull,
                  zsock_t * const push,
                  zsock_t * const pub,
                  pStats * const stats,
                  const int id,
                  const int thresh,
                  const int port_start,
                  const int fd_logfile,
                  const hashtrie trie,
                  const int proxynumber);

zsock_t *proxy_setup_pull(const int proxynumber);
zsock_t *proxy_setup_push(char const * const master_ip,
                          const int port_number);

struct p_pull_args {
    zsock_t *push;
    zsock_t *pub;
    pStats *stats;
    int proxy_id;
    int thresh;
    int port_start;
    int fd_logfile;
    hashtrie trie;
    int proxynumber;
};

int proxy_pull_reader(zloop_t *loop, zsock_t *reader, void *args);

struct queue_printer_arg {
    zsock_t *push;
    int proxy_id;
    pStats *stats;
    size_t iterations;
    int fd_logfile;
};

int print_queuesize_timer(zloop_t *loop, int timer_id, void *args);
void push_all_queuesizes(zsock_t * const push,
                         const int proxy_id,
                         pStats const * const stats,
                         const size_t iterations,
                         const int fd_logfile);

#endif
