#!/bin/bash

# create JUnit reports when calculating coverage
# running all tests might differ from the test suite used by make test
# to detect, check for errors again

mkdir -p testresults
rm -f testresults/*.xml
echo "<testsuite><testcase name=\"Hudson configuration\" classname=\"Configuration.Hudson\" time=\"0\"></testcase></testsuite>" > testresults/hudson.xml
export PROB_JUNIT_DIR="testresults"
export PROB_JUNIT=" -junit $PROB_JUNIT_DIR"

rm -rf Makefile_Coverage

rm -rf "./temp_coverage_data/"
mkdir -p "./temp_coverage_data/"

basepath="./coverage_reports"

rm -r $basepath
mkdir -p ${basepath}/emma/

for i in units laws units-and-laws regression all data_validation
do
   mkdir -p ${basepath}/html/$i
   mkdir -p ${basepath}/tex/$i
   mkdir -p ${basepath}/xml/$i
   mkdir -p ${basepath}/color/$i
done

export DONTSTOP=true
export TESTS_MULTIPLY_TIMEOUT=100
export PARALLEL=6

now=$(date "+%Y-%m-%d")

sicstus -l src/test_runner.pl --goal "generate_makefile_for_coverage, halt."
#sicstus -l src/prob_cov.pl --goal "generate_makefile, halt." was much slower
make -f Makefile_Coverage_Groups -j $PARALLEL -k

sicstus -l src/prob_cov.pl --goal "generate_report($now,units), halt ; halt".
sicstus -l src/prob_cov.pl --goal "generate_report($now,laws), halt ; halt".
sicstus -l src/prob_cov.pl --goal "generate_report($now,units-and-laws), halt ; halt".
sicstus -l src/prob_cov.pl --goal "generate_report($now,regression), halt ; halt".
sicstus -l src/prob_cov.pl --goal "generate_report($now,all), halt ; halt".
sicstus -l src/prob_cov.pl --goal "generate_report($now,data_validation), halt ; halt".
