% (c) 2009-2020 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)


:- use_module(tools).

:- dynamic benchmark/1, date/1.


mc_entry(BenchT,Date,Time) :- mc(B,Date,Time), get_tail_filename(B,BenchT).

init :- setof(B,Date^Time^mc_entry(B,Date,Time),Bench),
        sort(Bench,SB),
        print(SB),nl,
        member(B1,SB),
        assert(benchmark(B1)),fail.
init :- setof(D,B^Time^mc_entry(B,D,Time),Dates),
        sort(Dates,SB),
        print(SB),nl,
        member(D1,SB),
        assert(date(D1)),fail.
init.

p :- init, print_excel_table.

print_excel_table :- print_cell('Date'),
    benchmark(B), print_cell(B),
    fail.
print_excel_table :- nl,
    date(D),
    print_row(D),
    fail.
print_excel_table :- nl.

print_row(Date) :- print_cell(Date),
   benchmark(B),
   (mc_entry(B,Date,Time) -> print_cell(Time) ; print_cell('')),
   fail.
print_row(_) :- nl.


print_cell(X) :- print(X), print_sep.

print_sep :- print(', ').


main :- init,
        tell('benchmark_history/bench_out.csv'),
        print_excel_table,
        told.


% cat b_bench*.pl >benchall.pl
%:- include('../benchmark_history/benchall.pl').
