/* a file to start prob_cli with coverage/profiling info enabled (for SICStus 4.2 and later) */

%:- prolog_flag(compiling,_,debugcode). % debugcode leads to crash in coverage_data/1 in SICStus 4.6
% e.g., crash occurs for coverage_group_data('PROB-369'). See ticket SPRM-21038
:- prolog_flag(source_info,_,on).
:- prolog_flag(profiling,_,on).

%:- include(coverage_term_expander).

:- use_module(prob_cli).

:- use_module(coverage_tools).
:- use_module(test_runner).
:- use_module(tools_strings,[ajoin/2]).
:- use_module(version).

:- use_module(library(file_systems)).

% use module_info/3 because we are not in a module here
:- use_module(module_information,[module_info/3]).
:- module_info(prob_cov_runner,group,coverage_analysis).
:- module_info(prob_cov_runner,description,'ProB start file with coverage tests activated. Includes predicates to execute certain tests. Used by to generate coverage reports.').

% now in test_runner:
%generate_makefile :-
%    generate_makefile('Makefile_Coverage_Groups', write_coverage_target).
%write_coverage_target(G) :-
%   format('~w:\n\tsicstus -l src/prob_cov.pl --goal "coverage_group_data(\'~w\'), halt ; halt."',[G,G]),nl,nl.

% compute coverage for a testcase category (see testcases.pl for categories)
coverage_group_data(Category) :-
    % ids_in_category(Category,IDs),
    % load_coverage_files(IDs,CoverageData),
    run_silently,
    run_tests_by_category(Category,all),
    format('Obtaining coverage data for category ~w~n',[Category]), flush_output,
    coverage_data(CoverageData),
    write_coverage_data(Category,CoverageData).

% write collected coverage information to a Datafile
write_coverage_data(FileName,Data) :-
    ajoin(['./temp_coverage_data/', FileName],Path),
    format('Writing coverage data to ~w~n',[Path]), flush_output,
    open(Path,write,Stream),
    Out=cov(Data),
    write_canonical(Stream,Out),
    write(Stream,'.'),
    close(Stream).

