% (c) 2009-2020 Lehrstuhl fuer Softwaretechnik und Programmiersprachen,
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html)


:- use_module('../extensions/profiler/profiler.pl').    % (adds the profiler himself)
:- use_module('../extensions/profiler/profiler_te.pl'). % (adds the term expander)

portray_message(informational, _).

%:- coroutines(false).

%:- enable_profiling_all(eval_strings).
%:- enable_profiling_all(b_interpreter).

%:- enable_profiling(b_interpreter:b_test_boolean_expression2/_).
%:- enable_profiling(b_interpreter:b_not_test_boolean_expression2/_).
:- enable_profiling(b_interpreter:b_execute_while_loop/_).

:- enable_profiling_naming(b_interpreter:b_test_boolean_expression2/_,user:func1).
:- enable_profiling_naming(b_interpreter_check:b_check_boolean_expression2/_,user:func1).
:- enable_profiling_naming(b_interpreter:b_not_test_boolean_expression2/_,user:func1).
:- enable_profiling_naming(b_interpreter:b_compute_expression2/_,user:func1).
:- enable_profiling_naming(b_interpreter:b_execute_statement2/_,user:func1).
:- enable_profiling_naming(bsets_clp:image_wf/_,user:func12).
%:- enable_profiling_naming(bsets_clp:concatentation_of_sequences/_,user:func12).
:- enable_profiling_naming(bsets_clp:concs2/_,user:func12).
:- enable_profiling_naming(bsets_clp:prepend_sequence/_,user:func12).

% renaming predicate p(Functor, ListOfArgs, GeneratedAtom)
func1(N,[H|_],NFA) :- my_functor(H,F,A), tools_strings:ajoin([N,':',F,'/',A],NFA).
func12(N,[H1,H2|_],NFA) :- my_functor(H1,F1,A1), my_functor(H2,F2,A2),
                           tools:ajoin([N,':',F1,'/',A1,':',F2,'/',A2],NFA).

my_functor(V,F,N) :- var(V),!, F='_',N=0.
my_functor((_,_),F,N) :- !, F=pair, N=2. % avoid CSV complication
my_functor(T,F,N) :- functor(T,F,N).


:- include(prob_cli).

go_cli_pen :- go_cli,pen, print('Use file. to write output to a file.'),nl.
